#include <windows.h>
#include "math.h"

#define roundf(x) floor(x + 0.5f)

void line_DDA(HDC hdc, float x1, float y1, float x2, float y2)
{
	//       , 
	//    
	int iX1 = roundf(x1);
	int iY1 = roundf(y1);
	int iX2 = roundf(x2);
	int iY2 = roundf(y2);

	//    
	int deltaX = abs(iX1 - iX2);
	int deltaY = abs(iY1 - iY2);

	//    , 
	//   .      
	// ,   
	int length = max(deltaX, deltaY);

	//  ,      
	if (length == 0)
	{
		SetPixel(hdc, iX1, iY1, 0);
		return;
	}

	//          
	double dX = (x2 - x1) / length;
	double dY = (y2 - y1) / length;

	//  
	double x = x1;
	double y = y1;

	//  
	length++;
	while (length--)
	{
		x += dX;
		y += dY;
		SetPixel(hdc, roundf(x), roundf(y), 0);
	}
}